Index: c/src/lib/libbsp/powerpc/motorola_powerpc/ChangeLog
===================================================================
--- c/src/lib/libbsp/powerpc/motorola_powerpc/ChangeLog	(revision db0b36999d611a0e4b555cde9dc3210e41d5e1bc)
+++ c/src/lib/libbsp/powerpc/motorola_powerpc/ChangeLog	(revision 23090f33860ae60badb5eb6e781e99a79801720a)
@@ -1,2 +1,15 @@
+2003-09-29	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: Merge-in include/Makefile.am.
+	Reflect changes to bsp.am.
+	* include/Makefile.am: Remove.
+	* include/bsp.h: Add copy of ../shared/include/bsp.h (Violates BSP
+	coding standards).
+	* configure.ac: Reflect changes above.
+	* irq/Makefile.am: Fix header installation.
+	* motorola/Makefile.am: Fix header installation.
+	* openpic/Makefile.am: Fix header installation.
+	* pci/Makefile.am: Fix header installation.
+
 2003-09-26	Till Strauman <strauman@slac.stanford.edu>
 
Index: c/src/lib/libbsp/powerpc/motorola_powerpc/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/motorola_powerpc/Makefile.am	(revision db0b36999d611a0e4b555cde9dc3210e41d5e1bc)
+++ c/src/lib/libbsp/powerpc/motorola_powerpc/Makefile.am	(revision 23090f33860ae60badb5eb6e781e99a79801720a)
@@ -6,12 +6,51 @@
 
 # wrapup is the one that actually builds and installs the library
-#  from the individual .rel files built in other directories
-SUBDIRS = include clock console pci residual openpic irq vectors start \
-    startup bootloader motorola @exceptions@ vme wrapup
+# from the individual .rel files built in other directories
+SUBDIRS = . clock console pci residual openpic irq vectors start startup \
+    bootloader motorola @exceptions@ vme wrapup
 
 include $(top_srcdir)/../../bsp.am
 
-EXTRA_DIST = BOOTING README.MVME2300 README.OTHERBOARDS README.dec21140 \
-    bsp_specs times.mcp750 times.mvme2307
+include_bspdir = $(includedir)/bsp
+
+nodist_include_HEADERS += ../shared/include/nvram.h
+nodist_include_HEADERS += ../../shared/include/coverhd.h
+nodist_include_bsp_HEADERS = ../shared/console/consoleIo.h
+nodist_include_bsp_HEADERS += ../shared/console/uart.h
+nodist_include_bsp_HEADERS += ../shared/irq/irq.h 
+nodist_include_bsp_HEADERS += ../shared/motorola/motorola.h
+
+all-local: $(PREINSTALL_FILES)
+
+EXTRA_DIST = BOOTING README.MVME2300 README.OTHERBOARDS README.dec21140
+EXTRA_DIST += times.mcp750 times.mvme2307
+
+$(PROJECT_INCLUDE)/bsp:
+	@$(mkinstalldirs) $(PROJECT_INCLUDE)/bsp
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp
+
+$(PROJECT_INCLUDE)/bsp/consoleIo.h: ../shared/console/consoleIo.h
+	$(INSTALL_DATA) $< $@
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp/consoleIo.h
+
+$(PROJECT_INCLUDE)/bsp/uart.h: ../shared/console/uart.h
+	$(INSTALL_DATA) $< $@
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp/uart.h
+
+$(PROJECT_INCLUDE)/bsp/irq.h: ../shared/irq/irq.h
+	$(INSTALL_DATA) $< $@
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp/irq.h
+
+$(PROJECT_INCLUDE)/bsp/motorola.h: ../shared/motorola/motorola.h
+	$(INSTALL_DATA) $< $@
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp/motorola.h
+
+$(PROJECT_INCLUDE)/nvram.h: ../shared/include/nvram.h
+	$(INSTALL_DATA) $< $@
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/nvram.h
+
+$(PROJECT_INCLUDE)/coverhd.h: ../../shared/include/coverhd.h
+	$(INSTALL_DATA) $< $@
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/coverhd.h
 
 include $(top_srcdir)/../../../../automake/subdirs.am
Index: c/src/lib/libbsp/powerpc/motorola_powerpc/configure.ac
===================================================================
--- c/src/lib/libbsp/powerpc/motorola_powerpc/configure.ac	(revision db0b36999d611a0e4b555cde9dc3210e41d5e1bc)
+++ c/src/lib/libbsp/powerpc/motorola_powerpc/configure.ac	(revision 23090f33860ae60badb5eb6e781e99a79801720a)
@@ -40,5 +40,4 @@
 clock/Makefile
 console/Makefile
-include/Makefile
 irq/Makefile
 motorola/Makefile
Index: src/lib/libbsp/powerpc/motorola_powerpc/include/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/motorola_powerpc/include/Makefile.am	(revision db0b36999d611a0e4b555cde9dc3210e41d5e1bc)
+++ 	(revision )
@@ -1,59 +1,0 @@
-##
-## $Id$
-##
-
-include_HEADERS = bspopts.h
-
-include_HEADERS += ../../shared/include/nvram.h ../../shared/include/bsp.h \
-    ../../../shared/include/coverhd.h
-
-include_bspdir = $(includedir)/bsp
-include_bsp_HEADERS = ../../shared/console/consoleIo.h ../../shared/console/uart.h \
-    ../../shared/irq/irq.h ../../shared/motorola/motorola.h
-
-$(PROJECT_INCLUDE):
-	$(mkinstalldirs) $@
-
-$(PROJECT_INCLUDE)/bsp:
-	$(mkinstalldirs) $@
-
-$(PROJECT_INCLUDE)/%.h: %.h
-	$(INSTALL_DATA) $< $@
-
-$(PROJECT_INCLUDE)/nvram.h: ../../shared/include/nvram.h
-	$(INSTALL_DATA) $< $@
-
-$(PROJECT_INCLUDE)/bsp.h: ../../shared/include/bsp.h
-	$(INSTALL_DATA) $< $@
-
-$(PROJECT_INCLUDE)/coverhd.h: ../../../shared/include/coverhd.h
-	$(INSTALL_DATA) $< $@
-
-$(PROJECT_INCLUDE)/bsp/consoleIo.h: ../../shared/console/consoleIo.h
-	$(INSTALL_DATA) $< $@
-
-$(PROJECT_INCLUDE)/bsp/uart.h: ../../shared/console/uart.h
-	$(INSTALL_DATA) $< $@
-
-$(PROJECT_INCLUDE)/bsp/irq.h: ../../shared/irq/irq.h
-	$(INSTALL_DATA) $< $@
-
-$(PROJECT_INCLUDE)/bsp/motorola.h: ../../shared/motorola/motorola.h
-	$(INSTALL_DATA) $< $@
-
-TMPINSTALL_FILES = $(PROJECT_INCLUDE)
-TMPINSTALL_FILES += $(PROJECT_INCLUDE)/bspopts.h
-TMPINSTALL_FILES += $(PROJECT_INCLUDE)/bsp.h
-TMPINSTALL_FILES += $(PROJECT_INCLUDE)/nvram.h
-TMPINSTALL_FILES += $(PROJECT_INCLUDE)/coverhd.h
-
-TMPINSTALL_FILES += $(PROJECT_INCLUDE)/bsp
-TMPINSTALL_FILES += $(PROJECT_INCLUDE)/bsp/motorola.h
-TMPINSTALL_FILES += $(PROJECT_INCLUDE)/bsp/consoleIo.h
-TMPINSTALL_FILES += $(PROJECT_INCLUDE)/bsp/uart.h 
-TMPINSTALL_FILES += $(PROJECT_INCLUDE)/bsp/irq.h
-
-all-local: $(TMPINSTALL_FILES)
-
-include $(top_srcdir)/../../../../automake/force-preinstall.am
-include $(top_srcdir)/../../../../automake/local.am
Index: c/src/lib/libbsp/powerpc/motorola_powerpc/include/bsp.h
===================================================================
--- c/src/lib/libbsp/powerpc/motorola_powerpc/include/bsp.h	(revision 23090f33860ae60badb5eb6e781e99a79801720a)
+++ c/src/lib/libbsp/powerpc/motorola_powerpc/include/bsp.h	(revision 23090f33860ae60badb5eb6e781e99a79801720a)
@@ -0,0 +1,160 @@
+/*
+ *  bsp.h  -- contain BSP API definition.
+ *
+ *  Copyright (C) 1999 Eric Valette. valette@crf.canon.fr
+ *
+ *  The license and distribution terms for this file may be
+ *  found in found in the file LICENSE in this distribution or at
+ *  http://www.rtems.com/license/LICENSE.
+ *
+ * $Id$
+ */
+#ifndef LIBBSP_POWERPC_MOTOROLA_SHARED_BSP_H
+#define LIBBSP_POWERPC_MOTOROLA_SHARED_BSP_H
+
+#include <bspopts.h>
+
+#include <rtems.h>
+#include <console.h>
+#include <libcpu/io.h>
+#include <clockdrv.h>
+#include <bsp/vectors.h>
+
+/*
+ *  confdefs.h overrides for this BSP:
+ *   - termios serial ports (defaults to 1)
+ *   - Interrupt stack space is not minimum if defined.
+ */
+
+#define CONFIGURE_NUMBER_OF_TERMIOS_PORTS 2
+#define CONFIGURE_INTERRUPT_STACK_MEMORY  (16 * 1024)
+
+/* fundamental addresses for this BSP (PREPxxx are from libcpu/io.h) */
+#define	_IO_BASE			PREP_ISA_IO_BASE
+#define	_ISA_MEM_BASE		PREP_ISA_MEM_BASE
+/* address of our ram on the PCI bus   */
+#define	PCI_DRAM_OFFSET		PREP_PCI_DRAM_OFFSET
+/* offset of pci memory as seen from the CPU */
+#define PCI_MEM_BASE		PREP_ISA_MEM_BASE
+
+/*
+ *  base address definitions for several devices
+ *
+ */
+#define BSP_UART_IOBASE_COM1 ((_IO_BASE)+0x3f8)
+#define BSP_UART_IOBASE_COM2 ((_IO_BASE)+0x2f8)
+#define BSP_KBD_IOBASE       ((_IO_BASE)+0x60)
+#define BSP_VGA_IOBASE       ((_IO_BASE)+0x3c0)
+
+#define BSP_CONSOLE_PORT	BSP_UART_COM1
+#define BSP_UART_BAUD_BASE	115200
+  
+#include <bsp/openpic.h>
+#define BSP_PIC_DO_EOI openpic_eoi(0)
+
+
+#ifndef ASM
+#define outport_byte(port,value) outb(value,port)
+#define outport_word(port,value) outw(value,port)
+#define outport_long(port,value) outl(value,port)
+
+#define inport_byte(port,value) (value = inb(port))
+#define inport_word(port,value) (value = inw(port))
+#define inport_long(port,value) (value = inl(port))
+/*
+ * Vital Board data Start using DATA RESIDUAL
+ */
+/*
+ * Total memory using RESIDUAL DATA
+ */
+extern unsigned int BSP_mem_size;
+/*
+ * PCI Bus Frequency
+ */
+extern unsigned int BSP_bus_frequency;
+/*
+ * processor clock frequency
+ */
+extern unsigned int BSP_processor_frequency;
+/*
+ * Time base divisior (how many tick for 1 second).
+ */
+extern unsigned int BSP_time_base_divisor;
+
+#define BSP_Convert_decrementer( _value ) \
+  ((unsigned long long) ((((unsigned long long)BSP_time_base_divisor) * 1000000ULL) /((unsigned long long) BSP_bus_frequency)) * ((unsigned long long) (_value)))
+
+extern rtems_configuration_table  BSP_Configuration;
+extern void BSP_panic(char *s);
+extern void rtemsReboot(void);
+/* extern int printk(const char *, ...) __attribute__((format(printf, 1, 2))); */
+extern int BSP_disconnect_clock_handler (void);
+extern int BSP_connect_clock_handler (void);
+
+/* clear hostbridge errors
+ *
+ * enableMCP: whether to enable MCP checkstop / machine check interrupts
+ *            on the hostbridge and in HID0.
+ *
+ *            NOTE: HID0 and MEREN are left alone if this flag is 0
+ *
+ * quiet    : be silent
+ *
+ * RETURNS  : raven MERST register contents (lowermost 16 bits), 0 if
+ *            there were no errors
+ */
+extern unsigned long _BSP_clear_hostbridge_errors(int enableMCP, int quiet);
+
+
+/*
+ *  TM27 stuff
+ */
+
+#if defined(USE_ENHANCED_INTR_API) && defined(RTEMS_TM27)
+
+#include <bsp/irq.h>
+
+#define MUST_WAIT_FOR_INTERRUPT 1
+
+void nullFunc() {}
+static rtems_irq_connect_data clockIrqData = {BSP_DECREMENTER,
+					      0,
+					      (rtems_irq_enable)nullFunc,
+					      (rtems_irq_disable)nullFunc,
+					      (rtems_irq_is_enabled) nullFunc};
+void Install_tm27_vector(void (*_handler)())
+{
+  clockIrqData.hdl = _handler;
+  if (!BSP_install_rtems_irq_handler (&clockIrqData)) {
+	printk("Error installing clock interrupt handler!\n");
+	rtems_fatal_error_occurred(1);
+  }
+}
+
+#define Cause_tm27_intr()  \
+  do { \
+    unsigned32 _clicks = 8; \
+    asm volatile( "mtdec %0" : "=r" ((_clicks)) : "r" ((_clicks)) ); \
+  } while (0)
+
+
+#define Clear_tm27_intr() \
+  do { \
+    unsigned32 _clicks = 0xffffffff; \
+    asm volatile( "mtdec %0" : "=r" ((_clicks)) : "r" ((_clicks)) ); \
+  } while (0)
+
+#define Lower_tm27_intr() \
+  do { \
+    unsigned32 _msr = 0; \
+    _ISR_Set_level( 0 ); \
+    asm volatile( "mfmsr %0 ;" : "=r" (_msr) : "r" (_msr) ); \
+    _msr |=  0x8002; \
+    asm volatile( "mtmsr %0 ;" : "=r" (_msr) : "r" (_msr) ); \
+  } while (0)
+#endif
+
+
+#endif
+
+#endif
Index: c/src/lib/libbsp/powerpc/motorola_powerpc/irq/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/motorola_powerpc/irq/Makefile.am	(revision db0b36999d611a0e4b555cde9dc3210e41d5e1bc)
+++ c/src/lib/libbsp/powerpc/motorola_powerpc/irq/Makefile.am	(revision 23090f33860ae60badb5eb6e781e99a79801720a)
@@ -2,5 +2,4 @@
 ## $Id$
 ##
-
 
 VPATH = @srcdir@:@srcdir@/../../shared/irq
@@ -9,6 +8,6 @@
 C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.$(OBJEXT))
 
-# FIXME: this does give any sense here
-H_FILES = ../../shared/irq/irq.h
+include_bspdir = $(includedir)/bsp
+nodist_include_bsp_HEADERS = $(top_srcdir)/../shared/irq/irq.h
 
 S_FILES = irq_asm.S
@@ -24,5 +23,15 @@
 #
 
-all-local: $(ARCH) $(OBJS)
+all-local: $(ARCH) $(PREINSTALL_FILES) $(OBJS)
+
+PREINSTALL_FILES =
+
+$(PROJECT_INCLUDE)/bsp:
+	@$(mkinstalldirs) $(PROJECT_INCLUDE)/bsp
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp
+
+$(PROJECT_INCLUDE)/bsp/irq.h: $(top_srcdir)/../shared/irq/irq.h
+	$(INSTALL_DATA) $< $@
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp/irq.h
 
 include $(top_srcdir)/../../../../automake/local.am
Index: c/src/lib/libbsp/powerpc/motorola_powerpc/motorola/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/motorola_powerpc/motorola/Makefile.am	(revision db0b36999d611a0e4b555cde9dc3210e41d5e1bc)
+++ c/src/lib/libbsp/powerpc/motorola_powerpc/motorola/Makefile.am	(revision 23090f33860ae60badb5eb6e781e99a79801720a)
@@ -2,5 +2,4 @@
 ## $Id$
 ##
-
 
 VPATH = @srcdir@:@srcdir@/../../shared/motorola
@@ -10,5 +9,6 @@
 
 # FIXME: This doesn't give any sense here
-H_FILES = ../../shared/motorola/motorola.h
+include_bspdir = $(includedir)/bsp
+nodist_include_bsp_HEADERS = $(top_srcdir)/../shared/motorola/motorola.h
 
 OBJS = $(C_O_FILES)
@@ -25,3 +25,14 @@
 all-local: $(ARCH) $(OBJS)
 
+PREINSTALL_FILES =
+
+$(PROJECT_INCLUDE)/bsp:
+	@$(mkinstalldirs) $(PROJECT_INCLUDE)/bsp
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp
+
+$(PROJECT_INCLUDE)/bsp/motorola.h: \
+    $(top_srcdir)/../shared/motorola/motorola.h
+	$(INSTALL_DATA) $< $@
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp/motorola.h
+
 include $(top_srcdir)/../../../../automake/local.am
Index: c/src/lib/libbsp/powerpc/motorola_powerpc/openpic/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/motorola_powerpc/openpic/Makefile.am	(revision db0b36999d611a0e4b555cde9dc3210e41d5e1bc)
+++ c/src/lib/libbsp/powerpc/motorola_powerpc/openpic/Makefile.am	(revision 23090f33860ae60badb5eb6e781e99a79801720a)
@@ -2,5 +2,4 @@
 ## $Id$
 ##
-
 
 VPATH = @srcdir@:@srcdir@/../../shared/openpic
@@ -9,7 +8,5 @@
 
 include_bspdir = $(includedir)/bsp
-include_bsp_HEADERS = ../../shared/openpic/openpic.h
-
-H_FILES = ../../shared/openpic/openpic.h
+nodist_include_bsp_HEADERS = $(top_srcdir)/../shared/openpic/openpic.h
 
 OBJS = $(C_FILES:%.c=$(ARCH)/%.$(OBJEXT))
@@ -18,17 +15,15 @@
 include $(top_srcdir)/../../../../automake/lib.am
 
-$(PROJECT_INCLUDE)/bsp:
-	$(mkinstalldirs) $< $@
-
-$(PROJECT_INCLUDE)/bsp/openpic.h: ../../shared/openpic/openpic.h
-	$(INSTALL_DATA) $< $@
-
-#
-# (OPTIONAL) Add local stuff here using +=
-#
-
-PREINSTALL_FILES = $(PROJECT_INCLUDE)/bsp $(PROJECT_INCLUDE)/bsp/openpic.h
-
 all-local: $(ARCH) $(PREINSTALL_FILES) $(OBJS)
 
+PREINSTALL_FILES =
+
+$(PROJECT_INCLUDE)/bsp:
+	@$(mkinstalldirs) $(PROJECT_INCLUDE)/bsp
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp
+
+$(PROJECT_INCLUDE)/bsp/openpic.h: $(top_srcdir)/../shared/openpic/openpic.h
+	$(INSTALL_DATA) $< $@
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp/openpic.h
+
 include $(top_srcdir)/../../../../automake/local.am
Index: c/src/lib/libbsp/powerpc/motorola_powerpc/pci/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/motorola_powerpc/pci/Makefile.am	(revision db0b36999d611a0e4b555cde9dc3210e41d5e1bc)
+++ c/src/lib/libbsp/powerpc/motorola_powerpc/pci/Makefile.am	(revision 23090f33860ae60badb5eb6e781e99a79801720a)
@@ -2,5 +2,4 @@
 ## $Id$
 ##
-
 
 VPATH = @srcdir@:@srcdir@/../../shared/pci
@@ -10,7 +9,5 @@
 
 include_bspdir = $(includedir)/bsp
-include_bsp_HEADERS = ../../shared/pci/pci.h
-
-H_FILES = ../../shared/pci/pci.h
+nodist_include_bsp_HEADERS = $(top_srcdir)/../shared/pci/pci.h
 
 OBJS = $(C_O_FILES)
@@ -19,20 +16,19 @@
 include $(top_srcdir)/../../../../automake/lib.am
 
-#
-# (OPTIONAL) Add local stuff here using +=
-#
-
 AM_CFLAGS += -O2
 
-$(PROJECT_INCLUDE)/bsp:
-	$(mkinstalldirs) $<
-
-$(PROJECT_INCLUDE)/bsp/pci.h: ../../shared/pci/pci.h
-	$(INSTALL_DATA) $< $@
-
 # the .rel file built here will be put into libbsp.a by ../wrapup/Makefile
-PREINSTALL_FILES = $(PROJECT_INCLUDE)/bsp $(PROJECT_INCLUDE)/bsp/pci.h
 
 all-local: $(ARCH) $(PREINSTALL_FILES) $(OBJS)
 
+PREINSTALL_FILES =
+
+$(PROJECT_INCLUDE)/bsp:
+	@$(mkinstalldirs) $(PROJECT_INCLUDE)/bsp
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp
+
+$(PROJECT_INCLUDE)/bsp/pci.h: $(top_srcdir)/../shared/pci/pci.h
+	$(INSTALL_DATA) $< $@
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp/pci.h
+
 include $(top_srcdir)/../../../../automake/local.am