Index: c/src/ada-tests/mptests/mp14/mptest.ads
===================================================================
--- c/src/ada-tests/mptests/mp14/mptest.ads	(revision 35e4691b9a170a729b2908e9dfb67d4477266739)
+++ c/src/ada-tests/mptests/mp14/mptest.ads	(revision 23848bbd80f00aa8e271322f19871c0ba1366803)
@@ -107,6 +107,5 @@
 
    BUFFER_AREAS : array (  RTEMS.UNSIGNED32 range 1 .. 4 ) of RTEMS.BUFFER;
-   BUFFERS      : 
-      array (  RTEMS.UNSIGNED32 range 1 .. 4 ) of RTEMS.BUFFER_POINTER;
+   BUFFERS      : array (  RTEMS.UNSIGNED32 range 1 .. 4 ) of RTEMS.ADDRESS;
 
 --
@@ -142,5 +141,5 @@
 --
 
-   STOP_TEST : RTEMS.BOOLEAN;
+   STOP_TEST : BOOLEAN;
  
 --
@@ -240,106 +239,3 @@
    );
 
---
---  This is the Driver Address Table for this test.
---
-
-   DEVICE_DRIVERS : aliased RTEMS.DRIVER_ADDRESS_TABLE( 1 .. 1 ) :=
-   (1=>
-      (
-        CLOCK_DRIVER.INITIALIZE'ACCESS,              -- Initialization
-        RTEMS.NO_DRIVER_ENTRY,                       -- Open
-        RTEMS.NO_DRIVER_ENTRY,                       -- Close
-        RTEMS.NO_DRIVER_ENTRY,                       -- Read
-        RTEMS.NO_DRIVER_ENTRY,                       -- Write
-        RTEMS.NO_DRIVER_ENTRY                        -- Control
-      )
-   );
-
---
---  This is the Initialization Tasks Table for this test.
---
-
-   INITIALIZATION_TASKS : aliased RTEMS.INITIALIZATION_TASKS_TABLE( 1 .. 1 ) := 
-   (1=>
-     (
-       RTEMS.BUILD_NAME( 'U', 'I', '1', ' ' ),        -- task name
-       2048,                                          -- stack size
-       1,                                             -- priority
-       RTEMS.DEFAULT_ATTRIBUTES,                      -- attributes
-       MPTEST.INIT'ACCESS,                            -- entry point
-       RTEMS.TIMESLICE,                              -- initial mode
-       0                                              -- argument list
-     )
-   );
-
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
---                             BEGIN SUBPACKAGE                           --
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-
-   --
-   --  MPTEST.PER_NODE_CONFIGURATION / SPECIFICATION
-   --
-   --  DESCRIPTION:
-   --
-   --  This package is the specification for the subpackage
-   --  which will define the per node configuration parameters.
-   --
-   
-   package PER_NODE_CONFIGURATION is
-
-   --
-   --  LOCAL_NODE_NUMBER
-   --
-   --  DESCRIPTION:
-   --
-   --  This function returns the node number for this node.
-   --
-
-      function LOCAL_NODE_NUMBER 
-      return RTEMS.UNSIGNED32;
-  
-      pragma INLINE ( LOCAL_NODE_NUMBER );
-
-   end PER_NODE_CONFIGURATION;
-  
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
---                              END SUBPACKAGE                            --
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-
---
---  This is the Multiprocessor Configuration Table for this test.
---
-
-   MULTIPROCESSING_CONFIGURATION : aliased RTEMS.MULTIPROCESSING_TABLE := (
-      MPTEST.PER_NODE_CONFIGURATION.LOCAL_NODE_NUMBER,
-      2,                         -- maximum # nodes in system 
-      32,                        -- maximum # global objects
-      32                         -- maximum # proxies
-    );
-
---
---  This is the Configuration Table for this test.
---
-
-   CONFIGURATION : aliased RTEMS.CONFIGURATION_TABLE := (
-      RTEMS.NULL_ADDRESS,        -- will be replaced by BSP
-      64 * 1024,                 -- executive RAM size
-      10,                        -- maximum # tasks
-      12,                        -- maximum # timers
-      1,                         -- maximum # semaphores
-      1,                         -- maximum # message queues
-      1,                         -- maximum # messages
-      1,                         -- maximum # partitions
-      0,                         -- maximum # regions
-      0,                         -- maximum # dp memory areas
-      0,                         -- maximum # periods
-      0,                         -- maximum # user extensions
-      RTEMS.MILLISECONDS_TO_MICROSECONDS(10), -- # us in a tick
-      1                          -- # ticks in a timeslice
-  );
-
 end MPTEST;