Index: c/src/lib/libchip/serial/ns16550.c
===================================================================
--- c/src/lib/libchip/serial/ns16550.c	(revision 677a5039163544e238b5c80c2b346829223079b3)
+++ c/src/lib/libchip/serial/ns16550.c	(revision 27045a82afdfeadbad1453a5a36548e90cf560f7)
@@ -75,5 +75,5 @@
  *  Console Device Driver Entry Points
  */
-static boolean ns16550_probe(int minor)
+NS16550_STATIC boolean ns16550_probe(int minor)
 {
   /*
@@ -84,5 +84,5 @@
 }
 
-static void ns16550_init(int minor)
+NS16550_STATIC void ns16550_init(int minor)
 {
   unsigned32              pNS16550;
@@ -145,5 +145,5 @@
 }
 
-static int ns16550_open(
+NS16550_STATIC int ns16550_open(
   int      major,
   int      minor,
@@ -162,5 +162,5 @@
 }
 
-static int ns16550_close(
+NS16550_STATIC int ns16550_close(
   int      major,
   int      minor,
@@ -181,5 +181,5 @@
  *  ns16550_write_polled
  */
-static void ns16550_write_polled(
+NS16550_STATIC void ns16550_write_polled(
   int   minor, 
   char  cChar
@@ -226,5 +226,5 @@
  *  ns16550_assert_RTS
  */
-static int ns16550_assert_RTS(int minor)
+NS16550_STATIC int ns16550_assert_RTS(int minor)
 {
   unsigned32              pNS16550;
@@ -251,5 +251,5 @@
  *  ns16550_negate_RTS
  */
-static int ns16550_negate_RTS(int minor)
+NS16550_STATIC int ns16550_negate_RTS(int minor)
 {
   unsigned32              pNS16550;
@@ -280,5 +280,5 @@
  *  ns16550_assert_DTR
  */
-static int ns16550_assert_DTR(int minor)
+NS16550_STATIC int ns16550_assert_DTR(int minor)
 {
   unsigned32              pNS16550;
@@ -305,5 +305,5 @@
  *  ns16550_negate_DTR
  */
-static int ns16550_negate_DTR(int minor)
+NS16550_STATIC int ns16550_negate_DTR(int minor)
 {
   unsigned32              pNS16550;
@@ -340,5 +340,5 @@
  */
 
-static void ns16550_process(
+NS16550_STATIC void ns16550_process(
         int             minor
 )
@@ -407,5 +407,5 @@
 }
 
-static rtems_isr ns16550_isr(
+NS16550_STATIC rtems_isr ns16550_isr(
   rtems_vector_number vector
 )
@@ -423,5 +423,5 @@
  *  ns16550_flush
  */
-static int ns16550_flush(int major, int minor, void *arg)
+NS16550_STATIC int ns16550_flush(int major, int minor, void *arg)
 {
   while(!Ring_buffer_Is_empty(&Console_Port_Data[minor].TxBuffer)) {
@@ -452,5 +452,5 @@
  */
 
-static void ns16550_enable_interrupts(
+NS16550_STATIC void ns16550_enable_interrupts(
   int minor
 )
@@ -471,5 +471,5 @@
 }
 
-static void ns16550_initialize_interrupts(int minor)
+NS16550_STATIC void ns16550_initialize_interrupts(int minor)
 {
   ns16550_init(minor);
@@ -490,5 +490,5 @@
  *
  */
-static int ns16550_write_support_int(
+NS16550_STATIC int ns16550_write_support_int(
   int   minor, 
   const char *buf, 
@@ -555,5 +555,5 @@
  *
  */
-static int ns16550_write_support_polled(
+NS16550_STATIC int ns16550_write_support_polled(
   int         minor, 
   const char *buf, 
@@ -586,5 +586,5 @@
  */
 
-static int ns16550_inbyte_nonblocking_polled( 
+NS16550_STATIC int ns16550_inbyte_nonblocking_polled( 
   int minor 
 )
Index: c/src/lib/libchip/serial/ns16550_p.h
===================================================================
--- c/src/lib/libchip/serial/ns16550_p.h	(revision 677a5039163544e238b5c80c2b346829223079b3)
+++ c/src/lib/libchip/serial/ns16550_p.h	(revision 27045a82afdfeadbad1453a5a36548e90cf560f7)
@@ -22,4 +22,13 @@
 extern "C" {
 #endif
+
+/*
+ *  Define NS16550_STATIC to nothing while debugging so the entry points
+ *  will show up in the symbol table.
+ */
+
+#define NS16550_STATIC
+
+/* #define NS16550_STATIC static */
 
 /*
@@ -154,9 +163,9 @@
  */
 
-static boolean ns16550_probe(int minor);
-
-static void ns16550_init(int minor);
-
-static int ns16550_open(
+NS16550_STATIC boolean ns16550_probe(int minor);
+
+NS16550_STATIC void ns16550_init(int minor);
+
+NS16550_STATIC int ns16550_open(
   int major,
   int minor,
@@ -164,5 +173,5 @@
 );
 
-static int ns16550_close(
+NS16550_STATIC int ns16550_close(
   int major,
   int minor,
@@ -170,30 +179,30 @@
 );
 
-static void ns16550_write_polled(
+NS16550_STATIC void ns16550_write_polled(
   int   minor, 
   char  cChar
 );
 
-static int ns16550_assert_RTS(
-  int minor
-);
-
-static int ns16550_negate_RTS(
-  int minor
-);
-
-static int ns16550_assert_DTR(
-  int minor
-);
-
-static int ns16550_negate_DTR(
-  int minor
-);
-
-static void ns16550_initialize_interrupts(int minor);
-
-static int ns16550_flush(int major, int minor, void *arg);
-
-static int ns16550_write_support_int(
+NS16550_STATIC int ns16550_assert_RTS(
+  int minor
+);
+
+NS16550_STATIC int ns16550_negate_RTS(
+  int minor
+);
+
+NS16550_STATIC int ns16550_assert_DTR(
+  int minor
+);
+
+NS16550_STATIC int ns16550_negate_DTR(
+  int minor
+);
+
+NS16550_STATIC void ns16550_initialize_interrupts(int minor);
+
+NS16550_STATIC int ns16550_flush(int major, int minor, void *arg);
+
+NS16550_STATIC int ns16550_write_support_int(
   int   minor,
   const char *buf,
@@ -201,5 +210,5 @@
 );
 
-static int ns16550_write_support_polled(
+NS16550_STATIC int ns16550_write_support_polled(
   int   minor,
   const char *buf,
@@ -207,5 +216,5 @@
   );
 
-static int ns16550_inbyte_nonblocking_polled(
+NS16550_STATIC int ns16550_inbyte_nonblocking_polled(
   int minor
 );
Index: c/src/libchip/serial/ns16550.c
===================================================================
--- c/src/libchip/serial/ns16550.c	(revision 677a5039163544e238b5c80c2b346829223079b3)
+++ c/src/libchip/serial/ns16550.c	(revision 27045a82afdfeadbad1453a5a36548e90cf560f7)
@@ -75,5 +75,5 @@
  *  Console Device Driver Entry Points
  */
-static boolean ns16550_probe(int minor)
+NS16550_STATIC boolean ns16550_probe(int minor)
 {
   /*
@@ -84,5 +84,5 @@
 }
 
-static void ns16550_init(int minor)
+NS16550_STATIC void ns16550_init(int minor)
 {
   unsigned32              pNS16550;
@@ -145,5 +145,5 @@
 }
 
-static int ns16550_open(
+NS16550_STATIC int ns16550_open(
   int      major,
   int      minor,
@@ -162,5 +162,5 @@
 }
 
-static int ns16550_close(
+NS16550_STATIC int ns16550_close(
   int      major,
   int      minor,
@@ -181,5 +181,5 @@
  *  ns16550_write_polled
  */
-static void ns16550_write_polled(
+NS16550_STATIC void ns16550_write_polled(
   int   minor, 
   char  cChar
@@ -226,5 +226,5 @@
  *  ns16550_assert_RTS
  */
-static int ns16550_assert_RTS(int minor)
+NS16550_STATIC int ns16550_assert_RTS(int minor)
 {
   unsigned32              pNS16550;
@@ -251,5 +251,5 @@
  *  ns16550_negate_RTS
  */
-static int ns16550_negate_RTS(int minor)
+NS16550_STATIC int ns16550_negate_RTS(int minor)
 {
   unsigned32              pNS16550;
@@ -280,5 +280,5 @@
  *  ns16550_assert_DTR
  */
-static int ns16550_assert_DTR(int minor)
+NS16550_STATIC int ns16550_assert_DTR(int minor)
 {
   unsigned32              pNS16550;
@@ -305,5 +305,5 @@
  *  ns16550_negate_DTR
  */
-static int ns16550_negate_DTR(int minor)
+NS16550_STATIC int ns16550_negate_DTR(int minor)
 {
   unsigned32              pNS16550;
@@ -340,5 +340,5 @@
  */
 
-static void ns16550_process(
+NS16550_STATIC void ns16550_process(
         int             minor
 )
@@ -407,5 +407,5 @@
 }
 
-static rtems_isr ns16550_isr(
+NS16550_STATIC rtems_isr ns16550_isr(
   rtems_vector_number vector
 )
@@ -423,5 +423,5 @@
  *  ns16550_flush
  */
-static int ns16550_flush(int major, int minor, void *arg)
+NS16550_STATIC int ns16550_flush(int major, int minor, void *arg)
 {
   while(!Ring_buffer_Is_empty(&Console_Port_Data[minor].TxBuffer)) {
@@ -452,5 +452,5 @@
  */
 
-static void ns16550_enable_interrupts(
+NS16550_STATIC void ns16550_enable_interrupts(
   int minor
 )
@@ -471,5 +471,5 @@
 }
 
-static void ns16550_initialize_interrupts(int minor)
+NS16550_STATIC void ns16550_initialize_interrupts(int minor)
 {
   ns16550_init(minor);
@@ -490,5 +490,5 @@
  *
  */
-static int ns16550_write_support_int(
+NS16550_STATIC int ns16550_write_support_int(
   int   minor, 
   const char *buf, 
@@ -555,5 +555,5 @@
  *
  */
-static int ns16550_write_support_polled(
+NS16550_STATIC int ns16550_write_support_polled(
   int         minor, 
   const char *buf, 
@@ -586,5 +586,5 @@
  */
 
-static int ns16550_inbyte_nonblocking_polled( 
+NS16550_STATIC int ns16550_inbyte_nonblocking_polled( 
   int minor 
 )
Index: c/src/libchip/serial/ns16550_p.h
===================================================================
--- c/src/libchip/serial/ns16550_p.h	(revision 677a5039163544e238b5c80c2b346829223079b3)
+++ c/src/libchip/serial/ns16550_p.h	(revision 27045a82afdfeadbad1453a5a36548e90cf560f7)
@@ -22,4 +22,13 @@
 extern "C" {
 #endif
+
+/*
+ *  Define NS16550_STATIC to nothing while debugging so the entry points
+ *  will show up in the symbol table.
+ */
+
+#define NS16550_STATIC
+
+/* #define NS16550_STATIC static */
 
 /*
@@ -154,9 +163,9 @@
  */
 
-static boolean ns16550_probe(int minor);
-
-static void ns16550_init(int minor);
-
-static int ns16550_open(
+NS16550_STATIC boolean ns16550_probe(int minor);
+
+NS16550_STATIC void ns16550_init(int minor);
+
+NS16550_STATIC int ns16550_open(
   int major,
   int minor,
@@ -164,5 +173,5 @@
 );
 
-static int ns16550_close(
+NS16550_STATIC int ns16550_close(
   int major,
   int minor,
@@ -170,30 +179,30 @@
 );
 
-static void ns16550_write_polled(
+NS16550_STATIC void ns16550_write_polled(
   int   minor, 
   char  cChar
 );
 
-static int ns16550_assert_RTS(
-  int minor
-);
-
-static int ns16550_negate_RTS(
-  int minor
-);
-
-static int ns16550_assert_DTR(
-  int minor
-);
-
-static int ns16550_negate_DTR(
-  int minor
-);
-
-static void ns16550_initialize_interrupts(int minor);
-
-static int ns16550_flush(int major, int minor, void *arg);
-
-static int ns16550_write_support_int(
+NS16550_STATIC int ns16550_assert_RTS(
+  int minor
+);
+
+NS16550_STATIC int ns16550_negate_RTS(
+  int minor
+);
+
+NS16550_STATIC int ns16550_assert_DTR(
+  int minor
+);
+
+NS16550_STATIC int ns16550_negate_DTR(
+  int minor
+);
+
+NS16550_STATIC void ns16550_initialize_interrupts(int minor);
+
+NS16550_STATIC int ns16550_flush(int major, int minor, void *arg);
+
+NS16550_STATIC int ns16550_write_support_int(
   int   minor,
   const char *buf,
@@ -201,5 +210,5 @@
 );
 
-static int ns16550_write_support_polled(
+NS16550_STATIC int ns16550_write_support_polled(
   int   minor,
   const char *buf,
@@ -207,5 +216,5 @@
   );
 
-static int ns16550_inbyte_nonblocking_polled(
+NS16550_STATIC int ns16550_inbyte_nonblocking_polled(
   int minor
 );